
#include <vfw.h>

class CVideoCaptureCtrl : public COleControl
{
	DECLARE_DYNCREATE(CVideoCaptureCtrl)

public:
	CVideoCaptureCtrl();

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVideoCaptureCtrl)
	public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();
	//}}AFX_VIRTUAL

protected:
	~CVideoCaptureCtrl();

	DECLARE_OLECREATE_EX(CVideoCaptureCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CVideoCaptureCtrl)      // GetTypeInfo
	DECLARE_OLECTLTYPE(CVideoCaptureCtrl)		// Type name and misc status

	//{{AFX_MSG(CVideoCaptureCtrl)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	//{{AFX_DISPATCH(CVideoCaptureCtrl)
	CString m_compression;
	long m_colors;
	short m_deviceNr;
	afx_msg void OnDeviceNrChanged();
	BOOL m_autoSize;
	afx_msg void OnAutoSizeChanged();
	BOOL m_stretch;
	afx_msg void OnStretchChanged();
	long m_previewRate;
	afx_msg void OnPreviewRateChanged();
	BOOL m_capture;
	afx_msg void OnCaptureChanged();
	afx_msg long GetCaptureWidth();
	afx_msg long GetCaptureHeight();
	afx_msg BOOL GetDlgFormatQuery();
	afx_msg BOOL GetDlgSourceQuery();
	afx_msg BOOL GetDlgDisplayQuery();
	afx_msg void DlgFormat();
	afx_msg void DlgSource();
	afx_msg void DlgCompression();
	afx_msg void DlgDisplay();
	afx_msg void PlayAvi(LPCTSTR Filename);
	afx_msg void CaptureSingleFrame(LPCTSTR Filename);
	afx_msg void CaptureSequenceStart(LPCTSTR Filename);
	afx_msg void CaptureSequenceStop();
	afx_msg void StopAvi();
	afx_msg BSTR GetDeviceName(short nr);
	afx_msg OLE_HANDLE GetHWnd();
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

	afx_msg void AboutBox();

	//{{AFX_EVENT(CVideoCaptureCtrl)
	void FireOnFrame(long bmph, long data, long size)
		{FireEvent(eventidOnFrame,EVENT_PARAM(VTS_I4  VTS_I4  VTS_I4), bmph, data, size);}
	void FireResize(long x, long y)
		{FireEvent(eventidResize,EVENT_PARAM(VTS_I4  VTS_I4), x, y);}
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

public:
	enum {
	//{{AFX_DISP_ID(CVideoCaptureCtrl)
	dispidDeviceNr = 3L,
	dispidCaptureWidth = 8L,
	dispidCaptureHeight = 9L,
	dispidDlgFormatQuery = 10L,
	dispidDlgSourceQuery = 11L,
	dispidDlgDisplayQuery = 12L,
	dispidAutoSize = 4L,
	dispidStretch = 5L,
	dispidCompression = 1L,
	dispidPreviewRate = 6L,
	dispidColors = 2L,
	dispidCapture = 7L,
	dispidDlgFormat = 13L,
	dispidDlgSource = 14L,
	dispidDlgCompression = 15L,
	dispidDlgDisplay = 16L,
	dispidDeviceName = 22L,
	dispidPlayAvi = 17L,
	dispidCaptureSingleFrame = 18L,
	dispidCaptureSequenceStart = 19L,
	dispidCaptureSequenceStop = 20L,
	dispidStopAvi = 21L,
	eventidOnFrame = 1L,
	eventidResize = 2L,
	//}}AFX_DISP_ID
	};

   HWND hWnd;
   void FrameCallbackProc(long data, long size);
   CVideoCaptureCtrl *next, *prev;
   int m_width, m_height;
   int status;
   int blocked;

   void PlayAviTimer(void);
   UINT playavi;
   PAVISTREAM playavi_pavi;
   PAVIFILE	playavi_pfile;
   long playavi_lPos;
};

